/* Specify the memory areas */
MEMORY {
RAM (xrw)  : ORIGIN = 0x20000000, LENGTH = 2K
FLASH (rx) : ORIGIN = 0x08000000, LENGTH = 2K
}

/* Define output sections */
SECTIONS {
  /* The program code and other data goes into FLASH */
  .text : {
    . = ALIGN(4);
    KEEP(*(.vectors)) /* Startup code */
    . = ALIGN(4);
    *(.text)           /* .text sections (code) */
    . = ALIGN(4);
    _etext = .;        /* define a global symbols at end of code */
    *(.rodata)         /* .rodata sections (constants, strings, etc.) */
    . = ALIGN(4);
  } >FLASH

  /* Initialized data sections goes into RAM, load LMA copy after code */
  .data : {
    . = ALIGN(4);
    _sdata = .;        /* create a global symbol at data start */
    *(.data)           /* .data sections */
    . = ALIGN(4);
    _edata = .;        /* define a global symbol at data end */
  } >RAM AT> FLASH
  
  /* Uninitialized data section */
  .bss : {
    /* This is used by the startup in order to initialize the .bss secion */
    _sbss = .;         /* define a global symbol at bss start */
    *(.bss)
    . = ALIGN(4);
    _ebss = .;         /* define a global symbol at bss end */
  } >RAM
}
